
#ifndef MAIN_H
#define MAIN_H


#define	Led	            LATBbits.LATB7                      // led
#define	Led_Tris	    TRISBbits.TRISB7                    //    


                                                            // --- pin per SPI 1 - comunicazione con EasyCAT PRO -----
#define	Spi1Cs_	        LATCbits.LATC2
#define	SpiCs_Tris	    TRISCbits.TRISC2

#define	Spi1Sck	        LATCbits.LATC3
#define	Spi1Sck_Tris	TRISCbits.TRISC3

#define	Spi1Sdo	        LATCbits.LATC5
#define	Spi1Sdo_Tris	TRISCbits.TRISC5

#define	Spi1Sdi	        LATCbits.LATC4
#define	Spi1Sdi_Tris	TRISCbits.TRISC4


                                                            // --- pin per output digitali ----------------------------
#define Out_0           LATBbits.LATB5
#define Out_1           LATBbits.LATB4
#define Out_2           LATBbits.LATB3
#define Out_3           LATBbits.LATB2
#define Out_4           LATBbits.LATB1
#define Out_5           LATBbits.LATB0
#define Out_6           LATCbits.LATC7
#define Out_7           LATCbits.LATC6


                                                            // --- pin per input digitali ----------------------------
#define In_0            PORTAbits.RA2
#define In_1            PORTAbits.RA3
#define In_2            PORTAbits.RA4
#define In_3            PORTAbits.RA5
#define In_4            PORTAbits.RA7
#define In_5            PORTAbits.RA6
#define In_6            PORTCbits.RC0
#define In_7            PORTCbits.RC1


#define true 1
#define false 0


//---- typedef --------------------------------------------------------------------------

typedef union
{
    unsigned short  Word;
    unsigned char   Byte[2];
} UWORD;

typedef union
{
    unsigned long   Long;
    unsigned short  Word[2];
    unsigned char   Byte[4];
} ULONG;


//-------------------------- process data -----------------------------------------------

typedef union                               // output per la piastra base
{                                           //
  unsigned char  Byte[32];                  // si devono trasferire 32 byte tramite SPI
  unsigned long  Word[16];                  //
  unsigned long  Long[8];                   // 
}BUFFOUT;                                   //


typedef union                               // input dalla piastra base
{                                           //
  unsigned char  Byte[32];                  // si trasferiscono 32 byte tramite SPI 
  unsigned long  Word[16];                  // 
  unsigned long  Long[8];                   //  
}BUFFIN;

//---------------------------------------------------------------------------------------





#endif



